local mod = ...



-- Asset -------------------------------------------------------------------------------------
mod:registerAssetId("models/Authority2.fbx/Prefab/CookMaleFront", "PREFAB_AUTHORITY_COOK_MALE_FRONT")
mod:registerAssetId("models/Authority2.fbx/Prefab/CookMaleHat", "PREFAB_AUTHORITY_COOK_MALE_HAT")
mod:registerAssetId("models/Authority2.fbx/Prefab/CookFemaleFront", "PREFAB_AUTHORITY_COOK_FEMALE_FRONT")
mod:registerAssetId("models/Authority2.fbx/Prefab/CookFemaleHat", "PREFAB_AUTHORITY_COOK_FEMALE_HAT")



-- Job: Cook -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_AUTHORITY_COOK",
	JobName = "JOB_AUTHORITY_COOK_NAME",
	JobDescription = "JOB_AUTHORITY_COOK_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 60.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        -- RightHandObject = {
		-- 	DataType = "HAND_OBJECT",
        --     Model = "PREFAB_TOOL_GUARD_SPEAR"
        -- },
        MaleHatList = {
            "PREFAB_AUTHORITY_COOK_MALE_HAT",
        },
        MaleFrontList = {
            "PREFAB_AUTHORITY_COOK_MALE_FRONT",
        },
        MaleBeltList = {
            "PREFAB_AUTHORITY_BLANK",
        },
        FemaleHatList = {
            "PREFAB_AUTHORITY_COOK_FEMALE_HAT",
        },
        FemaleFrontList = {
            "PREFAB_AUTHORITY_COOK_FEMALE_FRONT",
        },
        FemaleBeltList = {
            "PREFAB_AUTHORITY_BLANK",
        },
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_COOK"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_COOK"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_COOK"
    }
})

mod:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_COOK"
    }
})



-- Job: Kitchen Helper -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_AUTHORITY_COOKHELPER",
	JobName = "JOB_AUTHORITY_COOKHELPER_NAME",
	JobDescription = "JOB_AUTHORITY_COOKHELPER_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 10.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        -- RightHandObject = {
		-- 	DataType = "HAND_OBJECT",
        --     Model = "PREFAB_TOOL_GUARD_SPEAR"
        -- },
        MaleHatList = {
            "PREFAB_AUTHORITY_COOK_MALE_HAT",
        },
        -- MaleFrontList = {
        --     "PREFAB_AUTHORITY_BUTLER_MALE_FRONT",
        -- },
        -- MaleBeltList = {
        --     "PREFAB_AUTHORITY_BLANK",
        -- },
        FemaleHatList = {
            "PREFAB_AUTHORITY_COOK_FEMALE_HAT",
        },
        -- FemaleFrontList = {
        --     "PREFAB_AUTHORITY_BUTLER_FEMALE_FRONT",
        -- },
        -- FemaleBeltList = {
        --     "PREFAB_AUTHORITY_BLANK",
        -- },
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_COOKHELPER"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_COOKHELPER"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_COOKHELPER"
    }
})

mod:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_COOKHELPER"
    }
})



-- Resource: Food -------------------------------------------------------------------------------------
mod:registerAssetId("icons/Food.png", "ICON_FOOD", "ATLAS_CELL")

mod:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_FOOD",
	ResourceName = "RESOURCE_FOOD_NAME",
	Icon = "ICON_FOOD",
	ResourceTypeList = { "RESOURCE_TYPE_AUTHORITY" },
	IsTradable = false,
    DisplayInInventory = false,
	DisplayInToolbar = false,
	OrderId = 0
})



-- Resource: Drink -------------------------------------------------------------------------------------
mod:registerAssetId("icons/Drink.png", "ICON_DRINK", "ATLAS_CELL")

mod:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_DRINK",
	ResourceName = "RESOURCE_DRINK_NAME",
	Icon = "ICON_DRINK",
	ResourceTypeList = { "RESOURCE_TYPE_AUTHORITY" },
	IsTradable = false,
    DisplayInInventory = false,
	DisplayInToolbar = false,
	OrderId = 0
})



-- Building Function: Pantry 1 -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_AUTHORITY_PANTRY1",
	Name = "BUILDING_FUNCTION_AUTHORITY_PANTRY1_NAME",
	HasMaximumInstance = true,
	MaximumInstanceAllowed = 1,
	WorkerCapacity = 1,
	UpkeepPerWorker = {
		{
			Resource = "GOLD_COINS",
			Quantity = 2
		}
	},
    RelatedJob = { 
        Job = "JOB_AUTHORITY_COOKHELPER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
        { Resource = "BOAR", Quantity = 10 },
        { Resource = "BREAD", Quantity = 10 },
	},
    ResourceListNeeded = {
        { Resource = "BOAR", Quantity = 1 },
        { Resource = "BREAD", Quantity = 1 },
	},
	ResourceProduced = {
        { Resource = "RESOURCE_FOOD", Quantity = 1 },
    }
})



-- Building Function: Pantry 2 -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_AUTHORITY_PANTRY2",
	Name = "BUILDING_FUNCTION_AUTHORITY_PANTRY2_NAME",
	HasMaximumInstance = true,
	MaximumInstanceAllowed = 1,
	WorkerCapacity = 1,
	UpkeepPerWorker = {
		{
			Resource = "GOLD_COINS",
			Quantity = 2
		}
	},
    RelatedJob = { 
        Job = "JOB_AUTHORITY_COOKHELPER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
        { Resource = "BV1_MEAT", Quantity = 10 },
        { Resource = "BREAD", Quantity = 10 },
	},
    ResourceListNeeded = {
        { Resource = "BV1_MEAT", Quantity = 1 },
        { Resource = "BREAD", Quantity = 1 },
	},
	ResourceProduced = {
        { Resource = "RESOURCE_FOOD", Quantity = 1 },
    }
})


-- Building Function: Pantry 3 -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_AUTHORITY_PANTRY3",
	Name = "BUILDING_FUNCTION_AUTHORITY_PANTRY3_NAME",
	HasMaximumInstance = true,
	MaximumInstanceAllowed = 1,
	WorkerCapacity = 1,
	UpkeepPerWorker = {
		{
			Resource = "GOLD_COINS",
			Quantity = 2
		}
	},
    RelatedJob = { 
        Job = "JOB_AUTHORITY_COOKHELPER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
        { Resource = "CHEESE", Quantity = 10 },
        { Resource = "BREAD", Quantity = 10 },
	},
    ResourceListNeeded = {
        { Resource = "CHEESE", Quantity = 1 },
        { Resource = "BREAD", Quantity = 1 },
	},
	ResourceProduced = {
        { Resource = "RESOURCE_FOOD", Quantity = 1 },
    }
})



-- Building Function: Buttery 1 -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_AUTHORITY_BUTTERY1",
	Name = "BUILDING_FUNCTION_AUTHORITY_BUTTERY1_NAME",
	HasMaximumInstance = true,
	MaximumInstanceAllowed = 1,
	WorkerCapacity = 1,
	UpkeepPerWorker = {
		{
			Resource = "GOLD_COINS",
			Quantity = 2
		}
	},
    RelatedJob = { 
        Job = "JOB_AUTHORITY_COOKHELPER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
        { Resource = "WINE", Quantity = 50 },
	},
    ResourceListNeeded = {
        { Resource = "WINE", Quantity = 1 },
	},
	ResourceProduced = {
        { Resource = "RESOURCE_DRINK", Quantity = 1 },
    }
})



-- Building Function: Buttery 2 -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_AUTHORITY_BUTTERY2",
	Name = "BUILDING_FUNCTION_AUTHORITY_BUTTERY2_NAME",
	HasMaximumInstance = true,
	MaximumInstanceAllowed = 1,
	WorkerCapacity = 1,
	UpkeepPerWorker = {
		{
			Resource = "GOLD_COINS",
			Quantity = 2
		}
	},
    RelatedJob = { 
        Job = "JOB_AUTHORITY_COOKHELPER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
        { Resource = "BEER", Quantity = 50 },
	},
    ResourceListNeeded = {
        { Resource = "BEER", Quantity = 1 },
	},
	ResourceProduced = {
        { Resource = "RESOURCE_DRINK", Quantity = 1 },
    }
})



-- Building Function: Buttery 3 -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_AUTHORITY_BUTTERY3",
	Name = "BUILDING_FUNCTION_AUTHORITY_BUTTERY3_NAME",
	HasMaximumInstance = true,
	MaximumInstanceAllowed = 1,
	WorkerCapacity = 1,
	UpkeepPerWorker = {
		{
			Resource = "GOLD_COINS",
			Quantity = 2
		}
	},
    RelatedJob = { 
        Job = "JOB_AUTHORITY_COOKHELPER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
        { Resource = "RESOURCE_CIDER", Quantity = 50 },
	},
    ResourceListNeeded = {
        { Resource = "RESOURCE_CIDER", Quantity = 1 },
	},
	ResourceProduced = {
        { Resource = "RESOURCE_DRINK", Quantity = 1 },
    }
})



-- Building Function List: Storage Chamber -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_AUTHORITY_STORAGE",
	AssetFunctionList = {
		"BUILDING_FUNCTION_AUTHORITY_PANTRY1",
		"BUILDING_FUNCTION_AUTHORITY_PANTRY2",
		"BUILDING_FUNCTION_AUTHORITY_PANTRY3",
		"BUILDING_FUNCTION_AUTHORITY_BUTTERY1",
		"BUILDING_FUNCTION_AUTHORITY_BUTTERY2",
		"BUILDING_FUNCTION_AUTHORITY_BUTTERY3",
		"BUILDING_FUNCTION_AUTHORITY_GOODS1",
		"BUILDING_FUNCTION_AUTHORITY_GOODS2",
		"BUILDING_FUNCTION_AUTHORITY_GOODS3",
	}
})



-- Building Function Assignable: Storage Chamber -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_AUTHORITY_STORAGE",
    AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_AUTHORITY_STORAGE"
})



-- Building Function: Kitchen -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_AUTHORITY_KITCHEN",
	Name = "BUILDING_FUNCTION_AUTHORITY_KITCHEN_NAME",
	HasMaximumInstance = true,
	MaximumInstanceAllowed = 1,
	WorkerCapacity = 1,
	UpkeepPerWorker = {
		{
			Resource = "GOLD_COINS",
			Quantity = 2
		}
	},
    RelatedJob = { 
        Job = "JOB_AUTHORITY_COOK", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
        { Resource = "RESOURCE_WAGE", Quantity = 50 },
        { Resource = "RESOURCE_FOOD", Quantity = 50 },
        { Resource = "RESOURCE_DRINK", Quantity = 50 },
	},
    ResourceListNeeded = {
        { Resource = "RESOURCE_WAGE", Quantity = 15 },
        { Resource = "RESOURCE_FOOD", Quantity = 1 },
        { Resource = "RESOURCE_DRINK", Quantity = 1 },
	},
	ResourceProduced = {
        { Resource = "RESOURCE_AUTHORITY", Quantity = 5 },
    }
})

