local mod = ...



-- Asset -------------------------------------------------------------------------------------
mod:registerAssetId("models/Authority2.fbx/Prefab/ChamberlainMaleFront", "PREFAB_AUTHORITY_CHAMBERLAIN_MALE_FRONT")
mod:registerAssetId("models/Authority2.fbx/Prefab/ChamberlainFemaleBelt", "PREFAB_AUTHORITY_CHAMBERLAIN_FEMALE_BELT")
mod:registerAssetId("models/Authority2.fbx/Prefab/ChamberlainFemaleFront", "PREFAB_AUTHORITY_CHAMBERLAIN_FEMALE_FRONT")

mod:registerAssetId("models/Authority2.fbx/Prefab/GroomMaleFront", "PREFAB_AUTHORITY_GROOM_MALE_FRONT")
mod:registerAssetId("models/Authority2.fbx/Prefab/GroomMaleHat", "PREFAB_AUTHORITY_GROOM_MALE_HAT")
mod:registerAssetId("models/Authority2.fbx/Prefab/GroomFemaleFront", "PREFAB_AUTHORITY_GROOM_FEMALE_FRONT")
mod:registerAssetId("models/Authority2.fbx/Prefab/GroomFemaleHat", "PREFAB_AUTHORITY_GROOM_FEMALE_HAT")



-- Job: Chamberlain -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_AUTHORITY_CHAMBERLAIN",
	JobName = "JOB_AUTHORITY_CHAMBERLAIN_NAME",
	JobDescription = "JOB_AUTHORITY_CHAMBERLAIN_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 60.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        -- RightHandObject = {
		-- 	DataType = "HAND_OBJECT",
        --     Model = "PREFAB_TOOL_GUARD_SPEAR"
        -- },
        MaleBeltList = {
            "PREFAB_AUTHORITY_BLANK",
        },
        MaleFrontList = {
            "PREFAB_AUTHORITY_CHAMBERLAIN_MALE_FRONT",
        },
        FemaleBeltList = {
            "PREFAB_AUTHORITY_CHAMBERLAIN_FEMALE_BELT",
        },
        FemaleFrontList = {
            "PREFAB_AUTHORITY_CHAMBERLAIN_FEMALE_FRONT",
        },
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_CHAMBERLAIN"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_CHAMBERLAIN"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_CHAMBERLAIN"
    }
})

mod:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_CHAMBERLAIN"
    }
})



-- Job: Groom -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_AUTHORITY_GROOM",
	JobName = "JOB_AUTHORITY_GROOM_NAME",
	JobDescription = "JOB_AUTHORITY_GROOM_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 10.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        -- RightHandObject = {
		-- 	DataType = "HAND_OBJECT",
        --     Model = "PREFAB_TOOL_GUARD_SPEAR"
        -- },
        MaleHatList = {
            "PREFAB_AUTHORITY_GROOM_MALE_HAT",
        },
        -- MaleFrontList = {
        --     "PREFAB_AUTHORITY_GROOM_MALE_FRONT",
        -- },
        -- MaleBeltList = {
        --     "PREFAB_AUTHORITY_BLANK",
        -- },
        FemaleHatList = {
            "PREFAB_AUTHORITY_GROOM_FEMALE_HAT",
        },
        -- FemaleFrontList = {
        --     "PREFAB_AUTHORITY_GROOM_FEMALE_FRONT",
        -- },
        -- FemaleBeltList = {
        --     "PREFAB_AUTHORITY_BLANK",
        -- },
        -- MaleClothingModel = {
        --     "PREFAB_AUTHORITY_GROOM_MALE_CLOTHES",
        -- },
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_GROOM"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_GROOM"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_GROOM"
    }
})

mod:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_AUTHORITY_GROOM"
    }
})



-- Resource: Orders (Goods) -------------------------------------------------------------------------------------
mod:registerAssetId("icons/Goods.png", "ICON_GOODS", "ATLAS_CELL")

mod:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_ORDERS_GOODS",
	ResourceName = "RESOURCE_ORDERS_GOODS_NAME",
	Icon = "ICON_GOODS",
	ResourceTypeList = { "RESOURCE_TYPE_AUTHORITY" },
	IsTradable = false,
    DisplayInInventory = false,
	DisplayInToolbar = false,
	OrderId = 0
})



-- Building Function: Chamberlain -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_AUTHORITY_CHAMBERLAIN",
	Name = "BUILDING_FUNCTION_AUTHORITY_CHAMBERLAIN_NAME",
	HasMaximumInstance = true,
	MaximumInstanceAllowed = 1,
	WorkerCapacity = 1,
	UpkeepPerWorker = {
		{
			Resource = "GOLD_COINS",
			Quantity = 10
		}
	},
    RelatedJob = { 
        Job = "JOB_AUTHORITY_CHAMBERLAIN", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
        { Resource = "RESOURCE_ORDERS_GOODS", Quantity = 5 },
    }
})



-- Building Function List: Lord Manor (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "BUILDING_FUNCTION_LIST_LORD_MANOR",
	AssetFunctionList = {
		Action = "APPEND",
		"BUILDING_FUNCTION_AUTHORITY_CHAMBERLAIN"
	}
})



-- Building Function: Goods 1 -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_AUTHORITY_GOODS1",
	Name = "BUILDING_FUNCTION_AUTHORITY_GOODS1_NAME",
	HasMaximumInstance = true,
	MaximumInstanceAllowed = 1,
	WorkerCapacity = 1,
	UpkeepPerWorker = {
		{
			Resource = "GOLD_COINS",
			Quantity = 2
		}
	},
    RelatedJob = { 
        Job = "JOB_AUTHORITY_GROOM", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
        { Resource = "RESOURCE_WAGE", Quantity = 10 },
        { Resource = "RESOURCE_ORDERS_GOODS", Quantity = 10 },
        { Resource = "CLOTHES", Quantity = 20 },
        { Resource = "RESOURCE_CANDLE", Quantity = 50 },
	},
    ResourceListNeeded = {
        { Resource = "RESOURCE_WAGE", Quantity = 15 },
        { Resource = "RESOURCE_ORDERS_GOODS", Quantity = 1 },
        { Resource = "CLOTHES", Quantity = 1 },
        { Resource = "RESOURCE_CANDLE", Quantity = 1 },
	},
	ResourceProduced = {
        { Resource = "RESOURCE_AUTHORITY", Quantity = 5 },
    }
})



-- Building Function: Goods 2 -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_AUTHORITY_GOODS2",
	Name = "BUILDING_FUNCTION_AUTHORITY_GOODS2_NAME",
	HasMaximumInstance = true,
	MaximumInstanceAllowed = 1,
	WorkerCapacity = 1,
	UpkeepPerWorker = {
		{
			Resource = "GOLD_COINS",
			Quantity = 2
		}
	},
    RelatedJob = { 
        Job = "JOB_AUTHORITY_GROOM", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
        { Resource = "RESOURCE_WAGE", Quantity = 10 },
        { Resource = "RESOURCE_ORDERS_GOODS", Quantity = 10 },
        { Resource = "RESOURCE_FURNITURE", Quantity = 20 },
        { Resource = "RESOURCE_CANDLE", Quantity = 50 },
	},
    ResourceListNeeded = {
        { Resource = "RESOURCE_WAGE", Quantity = 15 },
        { Resource = "RESOURCE_ORDERS_GOODS", Quantity = 1 },
        { Resource = "RESOURCE_FURNITURE", Quantity = 1 },
        { Resource = "RESOURCE_CANDLE", Quantity = 1 },
	},
	ResourceProduced = {
        { Resource = "RESOURCE_AUTHORITY", Quantity = 5 },
    }
})



-- Building Function: Goods 3 -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_AUTHORITY_GOODS3",
	Name = "BUILDING_FUNCTION_AUTHORITY_GOODS3_NAME",
	HasMaximumInstance = true,
	MaximumInstanceAllowed = 1,
	WorkerCapacity = 1,
	UpkeepPerWorker = {
		{
			Resource = "GOLD_COINS",
			Quantity = 2
		}
	},
    RelatedJob = { 
        Job = "JOB_AUTHORITY_GROOM", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
        { Resource = "RESOURCE_WAGE", Quantity = 10 },
        { Resource = "RESOURCE_ORDERS_GOODS", Quantity = 10 },
        { Resource = "RESOURCE_FURNITURE", Quantity = 20 },
        { Resource = "CLOTHES", Quantity = 1 },
	},
    ResourceListNeeded = {
        { Resource = "RESOURCE_WAGE", Quantity = 15 },
        { Resource = "RESOURCE_ORDERS_GOODS", Quantity = 1 },
        { Resource = "RESOURCE_FURNITURE", Quantity = 1 },
        { Resource = "CLOTHES", Quantity = 1 },
	},
	ResourceProduced = {
        { Resource = "RESOURCE_AUTHORITY", Quantity = 5 },
    }
})

